﻿@model string
@{
    ViewData["Title"] = "Edit";
}

<div class="alert alert-primary" role="alert">
    <p>Welcome to the new site editor. This is still in beta. Please send bug reports and feedback to the <a href="mailto:webmaster@siteguide.org.au">webmaster</a>.</p>
    <p>Some functions are still missing, for example uploading of images. You're always welcome to simply email the <a href="mailto:webmaster@siteguide.org.au">webmaster</a> all or some of the changes you require.</p>
</div>

<div id="app">
    <div class="pull-right" v-if="!pendingServerCall">
        @*<input type="submit" value="[debug] Save" v-on:click="saveSite" class="btn btn-info" />*@
        <a class="btn btn-primary" role="button" :href="data == null ? null : `/Versions/Compare/${data.requestedVersionTreeNode.editId}.${data.requestedVersionTreeNode.editVersionNumber}`" v-bind:class="{ disabled: data==null }">Show Changes</a>
        <a class="btn btn-primary" role="button" :href="data == null ? null : `/Sites/Details/${data.site.name}?editVersion=${data.requestedVersionTreeNode.idAndVersionNumber}`" v-bind:class="{ disabled: data==null }">Preview</a>
        <input type="submit" value="View Edit and Action" v-on:click="commitEdit" class="btn btn-primary" />
    </div>
    <h1>Edit Site</h1>
    <div class="alert alert-warning" role="alert" v-if="data">
        Edit {{data.requestedVersionTreeNode.editId}}.{{data.requestedVersionTreeNode.editVersionNumber}}
    </div>
    <div v-if="pendingServerCall">
        Loading site data...
        <div class="spinner-border spinner-border-sm" role="status">
            <span class="sr-only">Loading...</span>
        </div>
    </div>
    <template v-else>
        <!-- #region Site details -->
        <div data-entity-type="site" :data-entity-id="data.site.id">
            <div class="row">
                <div class="col-md-4">
                    <text-edit v-model="data.site.name" name="Name" v-on:change="fieldValueChanged($event)"></text-edit>
                </div>
                <div class="col-md-2">
                    <div class="form-group">
                        <label for="Area" class="control-label">Area</label>
                        <div id="Area">{{data.areaName}}</div>
                        @*                <select asp-for="AreaId" class="form-control" asp-items="ViewBag.AreaId"></select>*@
                    </div>
                </div>
                <div class="col-md-8">
                    <label for="isClosed">Site is </label>
                    <select id="isClosed" name="isClosed" v-model="data.site.isClosedSelect" v-on:change="isClosedChanged($event)">
                        <option value="o">open</option>
                        <option value="c">closed</option>
                    </select>
                    <div v-show="data.site.isClosedSelect==='c'">
                        <html-edit v-model="data.site.closed" name="Closed" v-on:change="fieldValueChanged($event)"></html-edit>
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col-md-12">
                    <text-edit v-model="data.site.rating" name="Rating" v-on:change="fieldValueChanged($event)"></text-edit>
                </div>
                <div class="col-md-6">
                    <text-edit v-model="data.site.height" name="Height" v-on:change="fieldValueChanged($event)"></text-edit>
                </div>
                <div class="col-md-6">
                    <text-edit v-model="data.site.type" name="Type" v-on:change="fieldValueChanged($event)"></text-edit>
                </div>
                <div class="col-md-12">
                    <text-edit v-model="data.site.conditions" name="Conditions" v-on:change="fieldValueChanged($event)"></text-edit>
                </div>
            </div>
            <div class="row">
                <div class="col-md-8">
                    <html-edit v-model="data.site.restrictions" name="Restrictions" v-on:change="fieldValueChanged($event)"></html-edit>
                </div>
            </div>
            <div class="row">
                <div class="col-md-8">
                    <text-edit v-model="data.site.shortLocation" name="ShortLocation" displayname="Short Location" v-on:change="fieldValueChanged($event)"></text-edit>
                </div>
                <div class="col-md-8">
                    <html-edit v-model="data.site.extendedLocation" name="ExtendedLocation" displayname="Extended Location" v-on:change="fieldValueChanged($event)"></html-edit>
                </div>
                <div class="col-md-8">
                    <html-edit v-model="data.site.description" name="Description" v-on:change="fieldValueChanged($event)"></html-edit>
                </div>
                <div class="col-md-8">
                    <html-edit v-model="data.site.takeoff" name="Takeoff" v-on:change="fieldValueChanged($event)"></html-edit>
                </div>
                <div class="col-md-8">
                    <html-edit v-model="data.site.landing" name="Landing" v-on:change="fieldValueChanged($event)"></html-edit>
                </div>
                <div class="col-md-8">
                    <html-edit v-model="data.site.landowners" name="Landowners" v-on:change="fieldValueChanged($event)"></html-edit>
                </div>
                <div class="col-md-8">
                    <html-edit v-model="data.site.flightComments" name="FlightComments" displayname="Flight Comments" v-on:change="fieldValueChanged($event)"></html-edit>
                </div>
                <div class="col-md-8">
                    <html-edit v-model="data.site.hazardsComments" name="HazardsComments" displayname="Hazards/Comments" v-on:change="fieldValueChanged($event)"></html-edit>
                </div>
            </div>
            <div class="row">
                <div class="col-md-6">
                    <text-edit v-model="data.site.smallPicture" name="SmallPicture" displayname="Small Picture" v-on:change="fieldValueChanged($event)"></text-edit>
                </div>
                <div class="col-md-6">
                    <text-edit v-model="data.site.smallPictureHref" name="SmallPictureHref" displayname="Small Picture Href" v-on:change="fieldValueChanged($event)"></text-edit>
                </div>
                <div class="col-md-6">
                    <text-edit v-model="data.site.smallPictureTitle" name="SmallPictureTitle" displayname="Small Picture Title" v-on:change="fieldValueChanged($event)"></text-edit>
                </div>
                <div class="col-md-6">
                    <div class="form-group">
                        <label for="InsetMapPosition" class="control-label">
                            Inset Map Position
                        </label>
                        <select v-model="data.site.insetMapPositionId" id="InsetMapPosition" class="form-control" name="InsetMapPositionId" v-on:change="fieldValueChanged($event)">
                            <option v-for="insetMapPosition in insetMapPositions" v-bind:value="insetMapPosition.id">
                                {{ insetMapPosition.name }}
                            </option>
                        </select>
                    </div>
                </div>
            </div>
        </div>
        <!-- #endregion -->
        <hr />
        <!-- #region Launches -->
        <div class="row">
            <div class="col-md-6">
                <h5>Launches</h5>
            </div>
            <div class="col-md">
                <div class="pull-right">
                    <button type="button" class="btn btn-primary" onclick="app.addLaunch()">Add Launch</button>
                </div>
            </div>
        </div>
        <div class="card" v-for="(launch, launchIndex) in data.launches">
            <div class="card-body" data-entity-type="launch" :data-entity-id="launch.id">
                <div class="row">
                    <div class="col-md-5">
                        <a class="btn btn-primary" title="Edit location" alt="Edit location" role="button" v-on:click="editLaunchLocation(launch)" style="color: white">
                            <template v-if="launch.lat==0 && launch.lon == 0">
                                Set coordinates
                            </template>
                            <template v-else>
                                <img alt="Map" width="240" height="240" :src="`https://maps.google.com/maps/api/staticmap?key=${mapApiKey}&amp;zoom=16&amp;size=240x240&amp;maptype=hybrid&markers=icon:@Model/mm_20_${launch.isClosedSelect=='o'?'green':'gray'}.png|${launch.lat},${launch.lon}`">
                                <div>
                                    {{launch.lat}}, {{launch.lon}}
                                </div>
                            </template>
                        </a>
                    </div>
                    <div class="col-md-5">
                        <text-edit v-model="launch.name" :id="`Name${launch.id}`" name="Name" v-on:change="fieldValueChanged($event)"></text-edit>
                        <text-edit v-model="launch.estaEmergencyMarker" :id="`EstaEmergencyMarker${launch.id}`" name="EstaEmergencyMarker" displayname="000 Emergency Marker" v-on:change="fieldValueChanged($event)"></text-edit>
                        <text-edit v-model="launch.conditions" name="Conditions" v-on:change="fieldValueChanged($event)"></text-edit>
                    </div>
                    <div class="col-md-2">
                        <div class="float-right">
                            <button type="button" class="btn btn-danger" v-on:click="onDeleteEntity($event)">Delete</button>
                        </div>
                    </div>
                </div>
                <div class="row mt-3">
                    <div class="col-md-6">
                        <html-edit v-model="launch.description" name="Description" v-on:change="fieldValueChanged($event)"></html-edit>
                    </div>
                    <div class="col-md-6">
                        <label :for="`isClosedLaunch${launch.id}`">Launch is </label>
                        <select :id="`isClosedLaunch${launch.id}`" name="isClosed" v-model="launch.isClosedSelect" v-on:change="isClosedChanged($event)">
                            <option value="o">open</option>
                            <option value="c">closed</option>
                        </select>
                        <div v-show="launch.isClosedSelect==='c'">
                            <html-edit v-model="launch.closed" name="Closed" v-on:change="fieldValueChanged($event)"></html-edit>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <!-- #endregion -->
        <hr />
        <!-- #region See Alsos -->
        <div class="row">
            <div class="col-md-6">
                <h5>See Also</h5>
            </div>
            <div class="col-md">
                <div class="pull-right">
                    <button type="button" class="btn btn-primary" onclick="app.add('seeAlso')">Add See Also</button>
                </div>
            </div>
        </div>
        <div class="card" v-for="(seeAlso, seeAlsoIndex) in data.seeAlsos">
            <div class="card-body">
                <div class="row" data-entity-type="seeAlso" :data-entity-id="seeAlso.id">
                    <div class="col-md-3">
                        <label :for="`isEntryStubForThis${seeAlso.id}`">Site entry is stub for this:</label>
                        <input type="checkbox" :id="`isEntryStubForThis${seeAlso.id}`" name="isEntryStubForThis" v-model="seeAlso.isEntryStubForThis" v-on:change="fieldValueChanged($event)" />
                    </div>
                    <div class="col-md-3">
                        <text-edit v-model="seeAlso.name" :id="`Name${seeAlso.id}`" name="Name" v-on:change="fieldValueChanged($event)"></text-edit>
                    </div>
                    <div class="col-md-4">
                        <text-edit v-model="seeAlso.link" :id="`Link${seeAlso.id}`" name="Link" v-on:change="fieldValueChanged($event)"></text-edit>
                    </div>
                    <div class="col-md">
                        <div class="float-right">
                            <button type="button" class="btn btn-danger" v-on:click="onDeleteEntity($event)">Delete</button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <!-- #endregion -->
        <hr />
        <!-- #region Contacts -->
        <div class="row">
            <div class="col-md-8">
                <h5>Contact/Responsible</h5>
            </div>
            <div class="col-md">
                <div class="float-right">
                    <button type="button" class="btn btn-primary" v-on:click="showAddContactModal()">Add Contact/Responsible</button>
                </div>
            </div>
        </div>
        <div class="row">
            <div class="col-md-6 col-xl-4" v-for="contact in data.contacts">
                <div data-entity-type="siteContact" :data-associated-entity-id="contact.contact.id">
                    <div class="clearfix">
                        <button type="button" class="btn btn-danger btn-sm float-right" v-on:click="disassociateContact(contact)">Remove</button>

                        @*<span class="badge badge-secondary" v-if="contact.isResponsible">Responsible</span>
                        <span class="badge badge-secondary" v-if="contact.isContact">Contact</span>
                        <div class="btn-group-toggle" data-toggle="buttons">
                        <label class="btn btn-secondary" v-bind:class="{ active: contact.isResponsible }">
                        <input type="checkbox" checked autocomplete="off" v-model="contact.isResponsible">Responsible
                        </label>
                        {{contact.isResponsible}}
                        </div>*@
                        <label :for="`isContact${contact.contact.id}`" class="badge" v-bind:class="{ 'badge-secondary': contact.isContact, 'badge-light': !contact.isContact }">
                            Contact
                            <input type="checkbox" :id="`isContact${contact.contact.id}`" name="isContact" v-model="contact.isContact" v-on:change="associationFieldValueChanged($event)">
                        </label>
                        <label :for="`isResponsible${contact.contact.id}`" class="badge" v-bind:class="{ 'badge-secondary': contact.isResponsible, 'badge-light': !contact.isResponsible }">
                            Responsible
                            <input type="checkbox" :id="`isResponsible${contact.contact.id}`" name='isResponsible' v-model="contact.isResponsible" v-on:change="associationFieldValueChanged($event)">
                        </label>
                    </div>
                    <div class="card">
                        <div class="card-body" data-entity-type="siteContact" :data-associated-entity-id="contact.contact.id">
                            <button type="button" class="btn btn-primary float-right" v-on:click="showEditContactModal(contact.contact)">Edit</button>

                            <h6>{{contact.contact.name}}</h6>
                            <div>{{contact.contact.fullName}}</div>
                            <div>{{contact.contact.address}}</div>
                            <div><a :href="contact.contact.link">{{contact.contact.link}}</a></div>
                            <div>{{contact.contact.phone}}</div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <!-- #endregion -->
        <hr />
        <!-- #region Map Shapes -->
        <h5>Map shapes</h5>
        <div class="row">
            <div class="col">
                <div id="shapeMap" style="width: 100%; height: 700px;"></div>
            </div>
        </div>
        <div id="mapshapesControlContainer">
            <div id="mapshapesListHeader">
                <div class="float-right">
                    <button class="btn btn-sm btn-primary" type="button" v-on:click="addMapshape()">
                        Add
                    </button>
                </div>
                <h6>Map shapes</h6>
            </div>
            <div id="mapshapesList">
                <ul class="list-group">
                    <template v-for="mapShape in data.mapShapes">
                        <li :id="'mapshapesListItem' + mapShape.id"
                            class="list-group-item"
                            v-bind:class="{ 'list-group-item-primary': mapShape == shapeMapActiveMapShape }"
                            v-on:click="setMapshapeEditMode(mapShape)">
                            <div class="float-right">
                                <div class="dropdown">
                                    <button class="btn btn-sm btn-primary dropdown-toggle" type="button" :id="'editMapshapeButton' + mapShape.id" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                        Edit
                                    </button>
                                    <div :id="'mapshape-dropdown-' + mapShape.id" class="dropdown-menu" :aria-labelledby="'editMapshapeButton' + mapShape.id">
                                        <button type="button" class="btn btn-sm btn-primary dropdown-item" v-on:click.stop="addSegment(mapShape)">Add Segment</button>
                                        <button type="button" class="btn btn-sm btn-primary dropdown-item" v-on:click.stop="showEditMapshapeModal(mapShape)">Details</button>
                                        <button type="button" class="btn btn-sm btn-danger  dropdown-item" v-on:click.stop="showRemoveMapshapeModal(mapShape)">Remove</button>
                                    </div>
                                </div>
                            </div>
                            <div>
                                {{mapShapeCategories.find(c=>c.id==mapShape.categoryId).name}}<span v-if="mapShape.name"> "{{mapShape.name}}"</span><span v-if="mapShape.description">: {{mapShape.description}}</span><span v-if="mapShape.estaEmergencyMarker"> <span class="triple-zero-emergency-marker">{{mapShape.estaEmergencyMarker}}</span></span>
                            </div>
                        </li>
                    </template>
                </ul>
            </div>
        </div>
        <!-- #endregion -->
        <hr />
        <!-- #region Videos -->
        <div class="row">
            <div class="col">
                <div class="pull-right">
                    <div class="dropdown">
                        <button class="btn btn-primary dropdown-toggle" type="button" id="addVideoMenuButton" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                            Add Video
                        </button>
                        <div class="dropdown-menu" aria-labelledby="addVideoMenuButton">
                            <a class="dropdown-item" v-on:click="showAddVideoModal(videoType)" v-for="videoType in videoTypes">{{videoType.name}}</a>
                        </div>
                    </div>
                </div>
                <h5>Videos</h5>
            </div>
        </div>
        <div class="row">
            <div class="col-lg-6" v-for="(video, videoIndex) in data.videos">
                <div class="card">
                    <div class="card-body" data-entity-type="video" :data-entity-id="video.id">
                        <div class="float-right">
                            <button type="button" class="btn btn-danger" v-on:click="onDeleteEntity($event)">Delete</button>
                        </div>
                        <iframe class="embedded-video" width=356 height=200 frameborder="0" :src="video.type.embedUrl.replace('%id', video.identifier)" webkitallowfullscreen mozallowfullscreen allowfullscreen>
                            &#160;@*&nbsp; - Hack to avoid collapsing element*@
                        </iframe>
                        @*<a :href="video.type.linkUrl.replace('%id', video.identifier)"><img :src="video.thumbnailUrl ?? (video.type.thumbnailUrl == null ? '[No thumbnail]' : video.type.thumbnailUrl.replace('%id', video.identifier))"></a>*@
                    </div>
                </div>
            </div>
        </div>
        <!-- #endregion -->
    </template>

    <!-- #region Modals -->
    <div class="modal fade" id="addContactModal" tabindex="-1" aria-labelledby="addContactModalLabel" aria-hidden="true">
        <div class="modal-dialog modal-dialog-centered">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="addContactModalLabel">Add Contact/Responsible</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <div class="clearfix">
                        @*<button type="button" class="btn btn-primary pull-right" onclick="app.createContactAndEdit()">New Contact</button>*@
                        Find:
                        <input type="text" v-model:value="addContactModal.contactFilter" v-on:input="filterContacts" />
                        <span v-if="addContactModal.filteredContacts && addContactModal.filteredContacts.length==0">No matches.</span>
                    </div>
                    <template v-if="!contacts">
                        Loading contacts...
                        <div class="spinner-border spinner-border-sm" role="status">
                            <span class="sr-only">Loading...</span>
                        </div>
                    </template>
                    <template v-else>
                        <div class="list-group" style="height:350px; overflow: auto;">
                            <button type="button" class="list-group-item list-group-item-action list-group-item-primary" v-on:click="createContactAndEdit()">
                                Create new contact ...
                            </button>
                            <button type="button" class="list-group-item list-group-item-action list-group-item-primary"
                                    v-for="contact in addContactModal.filteredContacts"
                                    v-bind:class="{ disabled: addContactModal.associatedContactIds.includes(contact.id) }"
                                    v-on:click="associateContact(contact)">
                                {{contact.name}} {{contact.fullName}}
                            </button>
                        </div>
                    </template>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Cancel</button>
                </div>
            </div>
        </div>
    </div>
    <div class="modal fade" id="editContactModal" tabindex="-1" aria-labelledby="editContactModalLabel" aria-hidden="true">
        <div class="modal-dialog modal-dialog-centered">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="editContactModalLabel">Edit Contact/Responsible</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body" v-if="editingContact">
                    <div class="form-group" data-entity-type="contact" :data-entity-id="editingContact.id">
                        <text-edit v-model="editingContact.name" id="editedContactName" name="Name" v-on:change="fieldValueChanged($event)"></text-edit>
                        <text-edit v-model="editingContact.fullName" id="editedContactFullName" name="FullName" displayname="Full Name" v-on:change="fieldValueChanged($event)"></text-edit>
                        <text-edit v-model="editingContact.phone" id="editedContactPhone" name="Phone" v-on:change="fieldValueChanged($event)"></text-edit>
                        <text-edit v-model="editingContact.link" id="editedContactLink" name="Link" v-on:change="fieldValueChanged($event)"></text-edit>
                        <text-edit v-model="editingContact.address" id="editedContactAddress" name="Address" v-on:change="fieldValueChanged($event)"></text-edit>
                        <div>Safa Club Id: {{editingContact.safaClubId ?? '[Not set]'}} @*TODO*@</div>
                        <div>Siteguide User: {{editingContact.userId ?? '[Not set]'}} @*TODO*@</div>
                    </div>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                </div>
            </div>
        </div>
    </div>
    <div class="modal fade" id="editMapshapeModal" tabindex="-1" aria-labelledby="editMapshapeModalLabel" aria-hidden="true">
        <div class="modal-dialog modal-dialog-centered">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="editMapshapeModalLabel">Edit Mapshape</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body" v-if="editingMapshape">
                    <div class="form-group" data-entity-type="mapshape" :data-entity-id="editingMapshape.id">
                        <label for="editedMapshapeCategory" class="control-label">
                            Category
                        </label>
                        <select v-model="editingMapshape.categoryId" id="editedMapshapeCategory" class="form-control" name="CategoryId" v-on:change="fieldValueChanged($event);onMapshapeCategoryUpdated(editingMapshape);">
                            <option v-for="category in mapShapeCategories" v-bind:value="category.id">
                                {{ category.name }}
                            </option>
                        </select>
                        <text-edit v-model="editingMapshape.name" id="editedMapshapeName" name="Name" v-on:change="fieldValueChanged($event)"></text-edit>
                        <html-edit v-model="editingMapshape.description" id="editedMapshapeDescription" name="Description" v-on:change="fieldValueChanged($event)"></html-edit>
                        <text-edit v-model="editingMapshape.estaEmergencyMarker" id="editedMapshapeEstaEmergencyMarker" name="estaEmergencyMarker" displayname="000 Emergency Marker" v-on:change="fieldValueChanged($event)"></text-edit>
                    </div>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                </div>
            </div>
        </div>
    </div>
    <div class="modal fade" id="removeMapshapeModal" tabindex="-1" aria-labelledby="removeMapshapeModalLabel" aria-hidden="true">
        <div class="modal-dialog modal-dialog-centered">
            <div class="modal-content" v-if="mapshapeAssociatedSites">
                <div class="modal-header">
                    <h5 class="modal-title" id="editMapshapeModalLabel">
                        Remove {{editingMapshape.category.name}}<span v-if="editingMapshape.name!=null && editingMapshape.name!=''"> "{{editingMapshape.name}}"</span>
                    </h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    This {{editingMapshape.category.name}} is currently associated with the following site(s):
                    <ul>
                        <li v-for="site in mapshapeAssociatedSites"><a :href="`/Sites/Details/${site.name}`">{{site.name}}</a></li>
                    </ul>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-danger" data-dismiss="modal" v-on:click="disassociateMapshape(editingMapshape)">Disassociate from {{data.site.name}} but keep on map</button>
                    <button type="button" class="btn btn-danger" data-dismiss="modal" v-on:click="deleteMapshape(editingMapshape)">Delete completely</button>
                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                </div>
            </div>
        </div>
    </div>
    <div class="modal fade" id="editLaunchModal" tabindex="-1" aria-labelledby="editLaunchModalLabel" aria-hidden="true">
        <div class="modal-dialog modal-dialog-centered">
            <div class="modal-content">
                <div class="modal-header">
                    <div>
                        <h5 class="modal-title" id="editLaunchModalLabel">{{(editingLaunch && editingLaunch.name) ? editingLaunch.name : 'Launch'}}</h5>
                        <div>Click on the map or drag the marker to change location.</div>
                    </div>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div id="launchMap" style="width: 100%; height: 450px; border: 7px solid white;"></div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                </div>
            </div>
        </div>
    </div>
    <div class="modal fade" id="addVideoModal" tabindex="-1" aria-labelledby="addVideoModalLabel" aria-hidden="true">
        <div class="modal-dialog modal-dialog-centered">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="addVideoModalLabel">Add {{newVideo.type.name}} video</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <div class="form-group">
                        <label for="newVideoIdentifier" class="control-label">Id</label>
                        <input type="text" maxlength="255" id="newVideoIdentifier" name="newVideoIdentifier" v-model="newVideo.identifier" class="form-control">
                    </div>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Cancel</button>
                    <button type="button" class="btn btn-primary" onclick="app.addVideo()">Add</button>
                </div>
            </div>
        </div>
    </div>
    <div id="savingToast" style="position: fixed;bottom: 0; right: 0" v-if="serverCallNotifications.length > 0">
        <template v-for="notification in serverCallNotifications">
            <div class="alert" v-bind:class="{ 'alert-primary': notification.status==='pending', 'alert-success': notification.status==='succeeded', 'alert-danger': notification.status==='failed' }" role="alert">
                <div class="spinner-border spinner-border-sm" role="status" v-if="notification.status==='pending'">
                    <span class="sr-only"></span>
                </div>
                {{notification.status === 'pending' ? notification.descriptionPresentParticiple : notification.status === 'succeeded' ? notification.descriptionPastParticiple : (notification.descriptionPresentParticiple + ' ' + notification.status)}}
            </div>
        </template>
    </div>
    <!-- #endregion -->
</div>

@section Scripts {
    @{
        await Html.RenderPartialAsync("_ValidationScriptsPartial");
    }
    <link rel="stylesheet" href="https://unpkg.com/easymde/dist/easymde.min.css">
    <environment include="Development">
        <script src="https://cdn.jsdelivr.net/npm/vue/dist/vue.js"></script>
    </environment>
    <environment exclude="Development">
        <script src="https://cdn.jsdelivr.net/npm/vue@2.7.14"></script>
    </environment>
    <script src="https://unpkg.com/easymde/dist/easymde.min.js"></script>
    <script src="https://maps.googleapis.com/maps/api/js?key=@ViewBag.GmapsApiKey&callback=&libraries=geometry&v=weekly" defer></script>
    <script src="~/js/edit.js"></script>
    <link rel="stylesheet" href="/css/edit.css" />

    <script type="text/x-template" id="text-edit-template">
        <div class="form-group">
            <label :for="id===undefined ? name : id" class="control-label">{{displayname ?? name}}</label>
            <input type="text"
                   maxlength="255"
                   :id="id===undefined ? name : id"
                   :name="name"
                   v-bind:value="value"
                   v-on:input="$emit('input', $event.target.value)"
                   v-on:change="$emit('change', $event)"
                   class="form-control" />
        </div>
    </script>
    <script type="text/x-template" id="html-edit-template">
        <div class="form-group">
            <label :for="name" class="control-label">{{displayname ?? name}}</label>
            <textarea :name="name"
                      v-bind:value="value"
                      v-on:input="$emit('input', $event.target.value)"
                      v-on:change="$emit('change', $event)"
                      class="form-control">
            </textarea>
        </div>
    </script>
}